package de.intevation.gnv.artifacts;

import de.intevation.artifacts.Artifact;
import de.intevation.artifacts.ArtifactFactory;
import de.intevation.artifacts.CallContext;

import java.io.FileOutputStream;

import org.apache.log4j.Logger;

import org.w3c.dom.Document;

/**
 * @author <a href="mailto:tim.englich@intevation.de">Tim Englich</a>
 *
 */
public class InstantaneousPointVerticalProfileTestCase extends
                                                      GNVArtifactsTestCaseBase {

    private static Logger log = Logger.getLogger(InstantaneousPointVerticalProfileTestCase.class);

    /**
     * Constructor
     */
    public InstantaneousPointVerticalProfileTestCase() {
    }

    /**
     * Constructor
     * @param name
     */
    public InstantaneousPointVerticalProfileTestCase(String name) {
        super(name);
    }

    /**
     * @see de.intevation.gnv.artifacts.GNVArtifactsTestCaseBase#testArtifact()
     */
    @Override
    public void testArtifact() {
        try {
            log.debug("GNVArtifactsTestCase.testVerticalProfileArtifact");
            String artefactName = "fis_bsh_ctd";
            ArtifactFactory artifactFactory = this
                    .getArtifactFactory(artefactName);
            assertNotNull(artifactFactory);
            log.debug("VerticalProfile-ArtifactFactory is available");

            Artifact artifact = createArtifact(artifactFactory);

            CallContext cc = createCallContext(artifactFactory);
            Document describeDocument = this.readDocument("src/test/ressources/verticalprofile_instantaneouspoint/verticalprofile_describe.xml");

           int steps = 5;

            for (int i = 1; i <= steps; i++){
                this.doNextStep(
                            artifact,
                            cc,
                            "src/test/ressources/verticalprofile_instantaneouspoint/" +
                            "verticalprofile_step_0"+i+"_feed.xml",
                            "src/test/ressources/verticalprofile_instantaneouspoint/" +
                            "verticalprofile_step_0"+i+"_advance.xml",
                            describeDocument);
            }

            // Vierter Schritt
            Document outputData = artifact.describe(describeDocument,cc);
            FileOutputStream fos = null;
            FileOutputStream fos2 = null;
            FileOutputStream fos3 = null;
            FileOutputStream fos4 = null;
            try {
                fos = new FileOutputStream(
                        "src/test/results/verticalprofile_instantaneouspoint"
                                + System.currentTimeMillis() + ".png");
                fos2 = new FileOutputStream(
                        "src/test/results/verticalprofile_instantaneouspoint"
                                + System.currentTimeMillis() + ".xml");
                fos3 = new FileOutputStream(
                        "src/test/results/verticalprofile_instantaneouspoint"
                                + System.currentTimeMillis() + ".csv");
                fos4 = new FileOutputStream(
                        "src/test/results/verticalprofile_instantaneouspoint"
                                + System.currentTimeMillis() + ".odv");
                artifact.out(this.readDocument("src/test/ressources/" +
                                               "verticalprofile_instantaneouspoint/" +
                                               "verticalprofile_step_05_out_statistics.xml"),
                             fos2, cc);
                artifact.out(this.readDocument("src/test/ressources/" +
                                               "verticalprofile_instantaneouspoint/" +
                                               "verticalprofile_step_05_out_chart.xml"),
                             fos, cc);
                artifact.out(this.readDocument("src/test/ressources/" +
                                               "verticalprofile_instantaneouspoint/" +
                                               "verticalprofile_step_05_out_csv.xml"),
                             fos3, cc);
                artifact.out(this.readDocument("src/test/ressources/" +
                                               "verticalprofile_instantaneouspoint/" +
                                               "verticalprofile_step_05_out_odv.xml"),
                             fos4, cc);
            } catch (Exception e) {
                log.error(e, e);
                fail();
            } finally {
                try {
                    fos.flush();
                    fos.close();
                    fos2.flush();
                    fos2.close();
                    fos3.flush();
                    fos3.close();
                } catch (Exception e) {
                    log.error(e, e);
                }
            }
        } catch (Exception e) {
            log.error(e, e);
            fail();
        }
    }

}
